import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Bowse  extends Actor
{
   private int avance;
    private int dir;
    private int dirImagen;
    private int contImagen;
    private int cont2;
    
    public Bowse()
    {
        avance = 2;
        dir= Greenfoot.getRandomNumber(4);
        dirImagen = 1;
        contImagen = 0;
        cont2 = 0;
    }
    
    /**
     * Mueve al objeto, lo anima, checa si es tocado por la explosion y si es cierto se remueve
     * 
     */
    public void act() 
    {
        mueve(dir);
        anima();
        contImagen++;
        
        if(contImagen == 4)
        {
           contImagen = 0;
        }
        
        if(cont2 == 100)
        {
           dir= Greenfoot.getRandomNumber(4);
           cont2 = 0;
        }
        cont2++;
        
        FlamaHR hr= (FlamaHR) getOneIntersectingObject(FlamaHR.class);
        FlamaHL hl= (FlamaHL) getOneIntersectingObject(FlamaHL.class);
        FlamaVA va= (FlamaVA) getOneIntersectingObject(FlamaVA.class);
        FlamaVB vb= (FlamaVB) getOneIntersectingObject(FlamaVB.class);
        CentroExplosion cE= (CentroExplosion) getOneIntersectingObject(CentroExplosion.class);
        

       
        if(hr != null || hl != null || va != null || vb != null || cE != null)
           getWorld().removeObject(this);
    }    
    
    /**
     * Anima al objeto
     * 
     */
    private void anima()
    {
        switch(contImagen) 
         {
             case 0 :
                    {
                        if(dirImagen == 0)
                         setImage("bowser0.png");
                         else
                           setImage("bowser00.png");
                    }
                break;
            case 1 :
                    {
                        if(dirImagen == 0)
                         setImage("bowser1.png");
                         else
                           setImage("bowser01.png");
                    }
                break;
            case 2 :
                    {
                        if(dirImagen == 0)
                         setImage("bowser2.png");
                         else
                           setImage("bowser02.png");
                    }
                break;
            case 3 :
                  {
                      if(dirImagen == 0)
                         setImage("bowser3.png");
                         else
                           setImage("bowser03.png");
                  }
                break;
                
        }
    }
    
    
    /**
     * Mueve al objeto en una direccion
     * 
     * @param recibe la direccion en la que debe de avanzar
     */
    private void mueve(int dir){
        
        
        switch(dir) 
         {
             case 0 :
                    {
                        avanza(0, -avance);
                    }
                break;
            case 1 :
                    {
                        avanza(0, avance);
                    }
                break;
            case 2 :
                    {
                        
                        avanza(-avance, 0);
                        dirImagen = 0;

                    }
                break;
            case 3 :
                  {
                        
                        avanza(avance, 0);
                        dirImagen = 1;
                  }
                break;
                
        }
        
    }
    
    /**
     * Mueve al objeto
     * 
     * @param dos enteros que son la direccion
     */
    private void avanza(int x, int y)
      {
        
        
        Pared pared= (Pared) getOneIntersectingObject(Pared.class);
        LadoV ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        LadoH ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        
        
        if(pared==null && ladov==null && ladoh == null)
        {
            setLocation(getX()+x,getY()+y);
        }
        
        pared= (Pared) getOneIntersectingObject(Pared.class);
        ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
       
        
        if(ladov!=null || ladoh != null || pared!=null)
        {
            setLocation(getX()-x,getY()-y);
            dir= Greenfoot.getRandomNumber(4);
        }
        
    }
}
