import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Bowser  extends Actor
{
    private int avance;
    private int dir;
    private int dirImagen;
    private int contImagen;
    private int cont2;
    private int contV;
    
    public Bowser()
    {
        avance = 4;
        dir= Greenfoot.getRandomNumber(4);
        dirImagen = 1;
        contImagen = 0;
        cont2 = 0;
        contV = 0;
    }
    
    /**
     * Mueve al objeto, lo anima, checa si es tocado por la explosion y si es cierto se remueve
     * 
     */
    public void act() 
    {
        mueve(dir);
        anima();
        contImagen++;
        
        if(contImagen == 13)
        {
           contImagen = 0;
        }
        
        if(cont2 == 50)
        {
           dir= Greenfoot.getRandomNumber(4);
           cont2 = 0;
        }
        cont2++;
        
        FlamaHR hr= (FlamaHR) getOneIntersectingObject(FlamaHR.class);
        FlamaHL hl= (FlamaHL) getOneIntersectingObject(FlamaHL.class);
        FlamaVA va= (FlamaVA) getOneIntersectingObject(FlamaVA.class);
        FlamaVB vb= (FlamaVB) getOneIntersectingObject(FlamaVB.class);
        CentroExplosion cE= (CentroExplosion) getOneIntersectingObject(CentroExplosion.class);
        

       
        if(hr != null || hl != null || va != null || vb != null || cE != null)
        {
            Greenfoot.playSound("explosion.wav");
            contV++;
        }
        
        if(contV == 120)
           getWorld().removeObject(this);
    }    
    
    /**
     * Anima al objeto
     * 
     */
    private void anima()
    {
        switch(contImagen) 
         {
             case 0 :
                    {
                        if(dirImagen == 0)
                         setImage("u0.png");
                         else
                           setImage("u00.png");
                    }
                break;
            case 4 :
                    {
                        if(dirImagen == 0)
                         setImage("u1.png");
                         else
                           setImage("u01.png");
                    }
                break;
            case 8 :
                    {
                        if(dirImagen == 0)
                         setImage("u2.png");
                         else
                           setImage("u02.png");
                    }
                break;
            case 12 :
                  {
                      if(dirImagen == 0)
                         setImage("u3.png");
                         else
                           setImage("u03.png");
                  }
                break;
                
        }
    }
    
    /**
     * Mueve al objeto en una direccion
     * 
     * @param recibe la direccion en la que debe de avanzar
     */
    
    private void mueve(int dir){
        
        
        switch(dir) 
         {
             case 0 :
                    {
                        avanza(0, -avance);
                    }
                break;
            case 1 :
                    {
                        avanza(0, avance);
                    }
                break;
            case 2 :
                    {
                        
                        avanza(-avance, 0);
                        dirImagen = 1;

                    }
                break;
            case 3 :
                  {
                        
                        avanza(avance, 0);
                        dirImagen = 0;
                  }
                break;
                
        }
        
    }
    
    /**
     * Mueve al objeto
     * 
     * @param dos enteros que son la direccion
     */
    private void avanza(int x, int y)
      {
        
        
        Pared pared= (Pared) getOneIntersectingObject(Pared.class);
        LadoV ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        Pared2 pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        LadoH ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        Bomba bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        Bomba2 bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(pared2==null && ladov==null && ladoh == null && pared2==null && bomba == null && bomba2 == null/*pared.isEmpty()*/)
        {
            setLocation(getX()+x,getY()+y);
        }
        
        pared= (Pared) getOneIntersectingObject(Pared.class);
        ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(pared2!=null  || ladov!=null || ladoh != null || pared!=null || bomba != null || bomba2 != null/*!pared.isEmpty()*/)
        {
            setLocation(getX()-x,getY()-y);
            dir= Greenfoot.getRandomNumber(4);
        }
        
    }
}
