import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Mario  extends Actor
{
    
    
    private int bombas;
    private boolean bom;
    private boolean bom2;
    private int velocidad;
    private int nivelBomba;
    private Numero numB;
    private Numero numV;
    private Numero numNB;   
    private boolean flama;
    private boolean tipoB;
    
    /**
     * Crea un objeto mario sencillo
     * 
     */
    public Mario()
    {
        bombas = 1; //Numero de bombas que puede poner
        velocidad = 1; //avance velocidad
        nivelBomba = 1; // nivel de la explosion
        bom = false;    // para cuando agrega una bomba
        bom = false;    // para cuando agrega una bomba
        numV = new Numero(); // visualizador
        numB = new Numero(); // visualizador
        numNB = new Numero(); // visualizador
        flama = false;
        tipoB = false;
        
    }
    
    /**
     * Crea un mario con valores inicializados
     * 
     * @param 3 enteros los cuales son los valores iniciales de bombas, velocidad y nivel de bomba
     */
    public Mario(int bombas, int velocidad, int nivelBomba)
    {
        this.bombas = bombas; //Numero de bombas que puede poner
        this.velocidad = velocidad; //avance velocidad
        this.nivelBomba = nivelBomba; // nivel de la explosion
        bom = false;    // para cuando agrega una bomba
        bom2 = false;    // para cuando agrega una bomba
        numV = new Numero(); // visualizador
        numB = new Numero(); // visualizador
        numNB = new Numero(); // visualizador
        flama = false;
        tipoB = false;
    }
        
    /**
     * Checa si se mueve el objeto, si se agrega una bomba y si cambia el nivel de las mejoras.
     *  
     */
    
    
    public void act() 
    {
        mueve();
        presion();
       
        getWorld().addObject(numNB, 83, 523);
        getWorld().addObject(numV, 193, 523);
        getWorld().addObject(numB, 303, 523);
       
        
        numV.cambiaNumero(velocidad);
        numB.cambiaNumero(bombas);
        numNB.cambiaNumero(nivelBomba);
        
        Bomba bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        
        if(bomba == null)
        {
            bom = false;
        }
        
        Bomba2 bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(bomba2 == null)
        {
            bom2 = false;
        }
        
        FlamaHR hr= (FlamaHR) getOneIntersectingObject(FlamaHR.class);
        FlamaHL hl= (FlamaHL) getOneIntersectingObject(FlamaHL.class);
        FlamaVA va= (FlamaVA) getOneIntersectingObject(FlamaVA.class);
        FlamaVB vb= (FlamaVB) getOneIntersectingObject(FlamaVB.class);
        Wario wario= (Wario) getOneIntersectingObject(Wario.class);
        Bowse bowse= (Bowse) getOneIntersectingObject(Bowse.class);
        Bows bows= (Bows) getOneIntersectingObject(Bows.class);
        Bow bow= (Bow) getOneIntersectingObject(Bow.class);
        CentroExplosion cE= (CentroExplosion) getOneIntersectingObject(CentroExplosion.class);
        List bowser=  getObjectsInRange(20,Bowser.class);
        

       
        if(hr != null || hl != null || va != null || vb != null || cE != null || bowse != null || bows != null || bow != null || wario != null || !bowser.isEmpty())
        {
           getWorld().removeObject(this);
           Greenfoot.playSound("risa.wav");
        }
    }    
    
    /**
     * Regresa un bolean para saber si se presiono la tecla de espacio
     * @return un boolean 
     */
    public boolean presion()
    {
        if(Greenfoot.isKeyDown("space"))
        {
            return true;
        }
        else
            return false;
    }
    
    /**
     * Aumenta el numero de bombas en 1
     *  
     */
    public void incrementaBombas()
    {
        if(bombas < 10)
        {
            bombas++;    
        }
    }  
    
    /**
     * Incrementa el numero de bombas al maximo
     *  
     */
    public void incrementaBombasM()
    {
            bombas = 9;
          
    }
    /**
     * Incrementa el numero de bombas que se pueden poner
     *  
     */
    public void incrementaNivelBomba()
    {
        if(nivelBomba < 10)
        {
             nivelBomba++;
             
        }
    }
    
    /**
     * Cambia el tipo de flama a la super flama
     *  
     */
    public void incrementaNivelFlamaS()
    {
       flama = true;
    }
    
    /**
     * Es para cambiar el tipo de flamas
     * 
     * @return un booleano para decir el tipo de flama
     */
    public boolean nivelFlamaS()
    {
       return flama;
    }
    
    /**
     * Aumenta al maximo el nivel de bombas 
     */
    public void incrementaNivelBombaM()
    {
        
             nivelBomba = 9;;
             
       
    }
    
    /**
     * Cambia el tipo de bomba normal, por la especial
     *  
     */
    public void cambiaBomba2()
    {
        tipoB = true;
    }
    
    /**
     * Aumenta la velocidad en 1 
     */
    public void incrementaVelocidad()
    {
        if(velocidad < 6)
        {
            velocidad++;
            
        }
    }
    
    /**
     * Pone al maximo la velocidad
     *  
     */
    public void incrementaVelocidadM()
    {
        
            velocidad = 7;
            
        
    }
    
    /**
     * Regresa el nivel el nivel de la bomba
     * @return un entero
     */
    public int getNB()
    {
        return nivelBomba;
    }
    
    /**
     * Mueve al objeto y pone bombas
     *  
     */
    public void mueve()
    {
        List bomb=  getWorld().getObjects(Bomba.class);
        List bomb2=  getWorld().getObjects(Bomba2.class);
        
        if(Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("A"))
        {
            
            if(bomb.size() < bombas && bomb2.size() < bombas)
            {
                
                agregaBomba();
                
                if(tipoB)
                   bom2 = true;
                   else
                     bom = true;
            }
        }
        else
          setImage("07.png");
        
        muevete(velocidad);
    }
    
    /**
     * Mueve al objeto dependiendo del boton que se presione
     * 
     * @param un entero que es el valor en pixeles que avanza 
     */
    
    private void muevete(int avance)
    {
        
        
        if(Greenfoot.isKeyDown("up"))
        {
            setImage("04.png");
            avanza(0,-avance-1);
        }
              
        if(Greenfoot.isKeyDown("down"))
        {
            setImage("01.png");
            avanza(0,avance+1);
        }
       // else
         //  setImage("07.png");
        
        if(Greenfoot.isKeyDown("left"))
        {
            setImage("02.png");
            avanza(-avance-1, 0);
        }
        
        if(Greenfoot.isKeyDown("right"))
        {
            setImage("06.png");
            avanza(avance+1, 0);
        }
        
         
                   
        
         
    }
        
    /**
     * Mueve al objeto
     * 
     * @param dos entero los cuales son la direccion del objeto
     */
    private void avanza(int x, int y){
        
        //List pared=  getObjectsInRange(40,Pared.class);
        Pared pared= (Pared) getOneIntersectingObject(Pared.class);
        LadoV ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        Pared2 pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        LadoH ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        //Bomba bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        List bomba=  getObjectsInRange(20,Bomba.class);
        List bomba2=  getObjectsInRange(20,Bomba2.class);

        
        if(pared2==null && ladov==null && ladoh == null && pared2==null && (bom || bomba.isEmpty()) &&  (bomba2.isEmpty() || bom2)/*pared.isEmpty()*/)
        {
            setLocation(getX()+x,getY()+y);
        }
        
        //pared=  getObjectsInRange(40,Pared.class);
        pared= (Pared) getOneIntersectingObject(Pared.class);
        ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        //bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        bomba=  getObjectsInRange(20,Bomba.class);
        bomba2=  getObjectsInRange(20,Bomba2.class);
        
        
        if((!bom && !bomba.isEmpty()) || (!bom2 && !bomba2.isEmpty()) || pared2!=null  || ladov!=null || ladoh != null || pared!=null /*!pared.isEmpty()*/)
        {
            setLocation(getX()-x,getY()-y);
        }
    }
    
    /**
     * Agrega una bomba 
     */
    
    private void agregaBomba()
    {
        Bomba bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        Bomba2 bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        if(bomba == null && bomba2 == null)
            creaBomba();
    }
    
    /**
     * Calcula la direccion en donde se va a crear la bomba
     * 
     * @return un entero, la cual es la direccion
     */
    
    private int calculaDir()
    {
        int gx = getX();
        int gy = getY();
        int dir = 65;
        int y = gy / 55;
        
        if(gx >= 0 && gx < 56)
        {
            dir = y;
        }
        else if(gx > 55 && gx < 111)
        {
            if(y == 0)
            {
                dir = 9 + y;
            }
            else if(y == 2)
            {
                dir = 8 + y;
            }
            else if(y == 4)
            {
                dir = 7 + y;
            }
            else if(y == 6)
            {
                dir = 6 + y;
            }
            else if(y == 8)
            {
                dir = 5 + y;
            }
        }
        else if(gx > 110 && gx < 166)
        {
            return (14 + gy/55);
        }
        else if(gx > 165 && gx < 221)
        {
             if(y == 0)
            {
                dir = 23 + y;
            }
            else if(y == 2)
            {
                dir = 22 + y;
            }
            else if(y == 4)
            {
                dir = 21 + y;
            }
            else if(y == 6)
            {
                dir = 20 + y;
            }
            else if(y == 8)
            {
                dir = 19 + y;
            }
        }
        else if(gx > 220 && gx < 276)
        {
            return (28 + gy/55);
        }
        else if(gx > 275 && gx < 331)
        {
             if(y == 0)
            {
                dir = 37 + y;
            }
            else if(y == 2)
            {
                dir = 36 + y;
            }
            else if(y == 4)
            {
                dir = 35 + y;
            }
            else if(y == 6)
            {
                dir = 34 + y;
            }
            else if(y == 8)
            {
                dir = 33 + y;
            }
        }
        else if(gx > 330 && gx < 386)
        {
            return (42 + gy/55);
        }
        else if(gx > 385 && gx < 441)
        {
             if(y == 0)
            {
                dir = 51 + y;
            }
            else if(y == 2)
            {
                dir = 50 + y;
            }
            else if(y == 4)
            {
                dir = 49 + y;
            }
            else if(y == 6)
            {
                dir = 48 + y;
            }
            else if(y == 8)
            {
                dir = 47 + y;
            }
        }
        else if(gx > 440 && gx < 496)
        {
            return (56 + gy/55);
        }
        
        return dir;
    }
    
    
    /**
     * Crea una bomba
     *
     */
    
    private void creaBomba()
    {
       
        
        switch(calculaDir()) 
         {
             case 0 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 28);
                            else
                               getWorld().addObject(new Bomba2(), 28, 28);
                    }
                break;
            case 1 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 83);
                            else
                               getWorld().addObject(new Bomba2(), 28, 83);
                    }
                break;
            case 2 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 138);
                            else
                               getWorld().addObject(new Bomba2(), 28, 138);
                    }
                break;
            case 3 :
                  {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 193);
                            else
                               getWorld().addObject(new Bomba2(), 28, 193);
                  }
                break;
            case 4 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 248);
                            else
                               getWorld().addObject(new Bomba2(), 28, 248);
                   }
                break;
            case 5 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 303);
                            else
                               getWorld().addObject(new Bomba2(), 28, 303);
                   }
                break;
            case 6 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 358);
                            else
                               getWorld().addObject(new Bomba2(), 28, 358);
                   }
                break;
            case 7 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 413);
                            else
                               getWorld().addObject(new Bomba2(), 28, 413);
                   }
                break;
            case 8 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 28, 468);
                            
                            else
                               getWorld().addObject(new Bomba2(), 28, 468);
                   }
                break;
            case 9 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 83, 28);
                            else
                               getWorld().addObject(new Bomba2(), 83, 28);
                   }
                break;
            case 10 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 83, 138);
                            else
                               getWorld().addObject(new Bomba2(), 83, 138);
                   }
                break;
            case 11 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 83, 248);
                            else
                               getWorld().addObject(new Bomba2(), 83, 248);
                   }
                break;
            case 12 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 83, 358);
                            else
                               getWorld().addObject(new Bomba2(), 83, 358);
                   }
                break;
            case 13 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 83, 468);
                            else
                               getWorld().addObject(new Bomba2(), 83, 468);
                   }
                break;
             case 14 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 28);
                            else
                               getWorld().addObject(new Bomba2(), 138, 28);
                    }
                break;
            case 15 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 83);
                            else
                               getWorld().addObject(new Bomba2(), 138, 83);
                    }
                break;
            case 16 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 138);
                            else
                               getWorld().addObject(new Bomba2(), 138, 138);
                    }
                break;
            case 17 :
                  {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 193);
                            else
                               getWorld().addObject(new Bomba2(), 138, 193);
                  }
                break;
            case 18 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 248);
                            else
                               getWorld().addObject(new Bomba2(), 138, 248);
                   }
                break;
            case 19 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 303);
                            else
                               getWorld().addObject(new Bomba2(),138 , 303);
                   }
                break;
            case 20 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 358);
                            else
                               getWorld().addObject(new Bomba2(), 138, 358);
                   }
                break;
            case 21 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 413);
                            else
                               getWorld().addObject(new Bomba2(), 138, 413);
                   }
                break;
            case 22 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 138, 468);
                            else
                               getWorld().addObject(new Bomba2(), 138, 468);
                   }
                break;
            case 23 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 193, 28);
                            else
                               getWorld().addObject(new Bomba2(), 193, 28);
                   }
                break;
            case 24 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 193, 138);
                            else
                               getWorld().addObject(new Bomba2(), 193, 138);
                   }
                break;
            case 25 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 193, 248);
                            else
                               getWorld().addObject(new Bomba2(), 193, 248);
                   }
                break;
            case 26 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 193, 358);
                            else
                               getWorld().addObject(new Bomba2(),193 ,358);
                   }
                break;
            case 27 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 193, 468);
                            else
                               getWorld().addObject(new Bomba2(),193 ,468);
                   }
                break;
             case 28 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 28);
                            else
                               getWorld().addObject(new Bomba2(),248 ,28);
                    }
                break;
            case 29 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 83);
                            else
                               getWorld().addObject(new Bomba2(),248 ,83);
                    }
                break;
            case 30 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 138);
                            else
                               getWorld().addObject(new Bomba2(),248 ,138);
                    }
                break;
            case 31 :
                  {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 193);
                            else
                               getWorld().addObject(new Bomba2(),248 ,193);
                  }
                break;
            case 32 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 248);
                            else
                               getWorld().addObject(new Bomba2(),248 ,248);
                   }
                break;
            case 33 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 303);
                            else
                               getWorld().addObject(new Bomba2(),248 ,303);
                   }
                break;
            case 34 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 358);
                            else
                               getWorld().addObject(new Bomba2(),248 ,358);
                   }
                break;
            case 35 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 413);
                            else
                               getWorld().addObject(new Bomba2(),248 ,413);
                   }
                break;
            case 36 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 248, 468);
                            else
                               getWorld().addObject(new Bomba2(),248 ,468);
                   }
                break;
            case 37 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 303, 28);
                            else
                               getWorld().addObject(new Bomba2(),303 ,28);
                   }
                break;
            case 38 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 303, 138);
                            else
                               getWorld().addObject(new Bomba2(),303 ,138);
                   }
                break;
            case 39 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 303, 248);
                            else
                               getWorld().addObject(new Bomba2(),303 ,248);
                   }
                break;
            case 40 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 303, 358);
                            else
                               getWorld().addObject(new Bomba2(),303 ,358);
                   }
                break;
            case 41 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 303, 468);
                            else
                               getWorld().addObject(new Bomba2(),303 ,468);
                   }
                break;
             case 42 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 28);
                            else
                               getWorld().addObject(new Bomba2(),358 ,28);
                    }
                break;
            case 43 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 83);
                            else
                               getWorld().addObject(new Bomba2(),358 ,83);
                    }
                break;
            case 44 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 138);
                            else
                               getWorld().addObject(new Bomba2(),358 ,138);
                    }
                break;
            case 45 :
                  {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 193);
                            else
                               getWorld().addObject(new Bomba2(),358 ,193);
                  }
                break;
            case 46 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 248);
                            else
                               getWorld().addObject(new Bomba2(),358 ,248);
                   }
                break;
            case 47 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 303);
                            else
                               getWorld().addObject(new Bomba2(),358 ,303);
                   }
                break;
            case 48 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 358);
                            else
                               getWorld().addObject(new Bomba2(),358 ,358);
                   }
                break;
            case 49 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 413);
                            else
                               getWorld().addObject(new Bomba2(),358 ,413);
                   }
                break;
            case 50 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 358, 468);
                            else
                               getWorld().addObject(new Bomba2(),358 ,468);
                   }
                break;
            case 51 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 413, 28);
                            else
                               getWorld().addObject(new Bomba2(),413 ,28);
                   }
                break;
            case 52 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 413, 138);
                            else
                               getWorld().addObject(new Bomba2(),413 ,138);
                   }
                break;
            case 53 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 413, 248);
                            else
                               getWorld().addObject(new Bomba2(),413 ,248);
                   }
                break;
            case 54 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 413, 358);
                            else
                               getWorld().addObject(new Bomba2(),413 ,358);
                   }
                break;
            case 55 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 413, 468);
                            else
                               getWorld().addObject(new Bomba2(),413 ,468);
                   }
                break;
             case 56 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 28);
                            else
                               getWorld().addObject(new Bomba2(),468 ,28);
                    }
                break;
            case 57 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 83);
                            else
                               getWorld().addObject(new Bomba2(),468 ,83);
                    }
                break;
            case 58 :
                    {
                        if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 138);
                            else
                               getWorld().addObject(new Bomba2(),468 ,138);
                    }
                break;
            case 59 :
                  {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 193);
                            else
                               getWorld().addObject(new Bomba2(),468 ,193);
                  }
                break;
            case 60 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 248);
                            else
                               getWorld().addObject(new Bomba2(),468 ,248);
                   }
                break;
            case 61 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 303);
                            else
                               getWorld().addObject(new Bomba2(),468 ,303);
                   }
                break;
            case 62 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 358);
                            else
                               getWorld().addObject(new Bomba2(),468 ,358);
                   }
                break;
            case 63 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 413);
                            else
                               getWorld().addObject(new Bomba2(),468 ,413);
                   }
                break;
            case 64 :
                   {
                       if(!tipoB)
                            getWorld().addObject(new Bomba(), 468, 468);
                            else
                               getWorld().addObject(new Bomba2(),468 ,468);
                   }
                break;
         }
    
    
    }
    
    
    
    
    
    
}
