import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */

     
public class MarioBomberman  extends World
{

    private int cont;
    private int contV;
    private boolean scenario;
    private boolean v;
    private Boton b1;
    private Boton b2;
    public MarioBomberman()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        
        super(550, 550, 1); 
        
        cont = 0;
        contV = 3;
        v = false;
        scenario = false;
        b1 = new Boton();
        b2 = new Boton();
        addObject(b1, 71, 484);
        addObject(b2, 452, 485);
        Greenfoot.start();
        Greenfoot.playSound("ini.wav");
        
    }
    
    /**
     * En este metodo actua el mundo, checa si se dio click en el boton play o en el help, para
     * asi poder acceder a sus respectivos fondos, ya una ve empezado el juego, este mismo metodo
     * checa si se perdio, gano o avanzo de nivel.
     * 
     */
    public void act()
    {
        //checa para iniciar el juego
        if(Greenfoot.mouseClicked(b2))
        {
           removeObjects(getObjects(Boton.class));
           scenario = true;
           v = true;
        }
        //checa para ver la ayuda
        if(Greenfoot.mouseClicked(b1))
        {
           removeObject(b1);
           setBackground("help.png");
        }
        
        //para cargar los scenarios
        if(scenario)
        {  
            creaScenario(cont);
            Greenfoot.playSound("nivel.wav");
            scenario = false;
            Greenfoot.delay(100);
        }
        
        
        // para volver a recargar el scenario si es matado mario
        List mario=  getObjects(Mario.class);
        if(mario.isEmpty() && contV > 0 && v)
        {
            contV--;
            removeObjects(getObjects(Object.class));
            
            if(contV > 0)
               creaScenario(cont);
            
            Greenfoot.delay(100);
        }
        
        
        // checa si ya perdio
        if(contV == 0)
        {
            contV = -1;
            removeObjects(getObjects(Object.class));
            setBackground("gm.png");
            Greenfoot.playSound("go.wav");
            Greenfoot.delay(200);
            
                
        }
        
        
        //checa si hay enemigo, si no hay avanza de nivel
        List wario=  getObjects(Wario.class);
        List bowser=  getObjects(Bowser.class);
        List bowse=  getObjects(Bowse.class);
        List bows=  getObjects(Bows.class);
        List bow=  getObjects(Bow.class);
        
        if(wario.isEmpty() && bowse.isEmpty() && bows.isEmpty() && bow.isEmpty() && contV > 0 && bowser.isEmpty() && v)
        {
            removeObjects(getObjects(Object.class));
            scenario = true;    
            cont++;
        }
        
        // checa si ya gano
        if(cont == 6 && v)
        {
           
            setBackground("Wn.png");
            Greenfoot.playSound("win.wav");
            v = false;
            scenario = false;
            Greenfoot.delay(400);
                
        }
    }
    
    /**
     * Crea los escenarios de los niveles, recibiendo el numero del escenario a crear
     * 
     * @param recibe un entero que es el numero de escenario que creara
     */
    private void creaScenario(int nScenario)
    {
        //Mario mario = new Mario();
        
        
        switch(nScenario) 
         {
             case 0 :
                    {
                        siempre();
                        Mario mario = new Mario(1,1,1);
                        addObject(mario , 28, 28);
                        scenario(50);
                        visualizaVida();
                        visualizaNivel();
                        creaEnemigos(2, 0);
                        creaEnemigos(1, 1);
                    }
                break;
            case 1 :
                    {
                        siempre();
                        Mario mario = new Mario(1,1,1);
                        addObject(mario , 28, 28);
                        scenario(40);
                        visualizaVida();
                        visualizaNivel();
                        creaEnemigos(2, 0);
                        creaEnemigos(1, 1);
                        creaEnemigos(1, 2);
                    }
                break;
            case 2 :
                    {
                        siempre();
                        Mario mario = new Mario(2,2,2);
                        addObject(mario , 28, 28);
                        scenario(30);
                        visualizaVida();
                        visualizaNivel();
                        creaEnemigos(3, 0);
                        creaEnemigos(2, 1);
                        creaEnemigos(1, 2);
                    }
                break;
            case 3 :
                   {
                        siempre();
                        Mario mario = new Mario(3,3,3);
                        addObject(mario , 28, 28);
                        scenario(20); 
                        visualizaVida();
                        visualizaNivel();
                        creaEnemigos(2, 0);
                        creaEnemigos(2, 1);
                        creaEnemigos(2, 2);
                        creaEnemigos(1, 3);
                   }
                break;
            case 4 :
                   {
                        siempre();
                        Mario mario = new Mario(4,4,4);
                        addObject(mario , 28, 28);
                        scenario(10);
                        visualizaVida();
                        visualizaNivel();
                        creaEnemigos(2, 0);
                        creaEnemigos(2, 1);
                        creaEnemigos(2, 2);
                        creaEnemigos(2, 3);
                   }
                break;
            case 5 :
                   {
                       scenarioFinal();
                       Mario mario = new Mario(4,4,4);
                       addObject(mario , 28, 28);
                       visualizaVida();
                       visualizaNivel();
                       addObject(new Bowser(), 248, 248);
                       
                   }
                break;
            
        }
          
        addObject(new Flama(), 28, 523);
        addObject(new Llanta(), 138, 523);
        addObject(new Bomb(), 248, 523);
        
    }
    
    /**
     * Crea el escenario final
     * 
     */
    private void scenarioFinal()
    {
        setBackground("fondo-2.png");
        addObject(new Pared(), 83, 83);
        addObject(new Pared(), 83, 413);
        addObject(new Pared(), 413, 83);
        addObject(new Pared(), 413, 413);
        
        int aux = 55;
        
        for(int i = 0; i < 10; i++){
            addObject(new Pared(), 28 + aux*i ,522 );
            addObject(new Pared(), 522, 28 + aux*i);
        }
        
        for(int k = 0; k < 5; k++)
        {
            agregaMejora(138  + aux*k, 138);
            addObject(new Pared2(), 138 + aux*k, 138);
            
            agregaMejora(138  + aux*k, 358);
            addObject(new Pared2(), 138  + aux*k, 358);
            
            agregaMejora(138, 138  + aux*k);
            addObject(new Pared2(), 138, 138 + aux*k);
            
            agregaMejora(358, 138 + aux*k);
            addObject(new Pared2(), 358, 138 + aux*k);
        }
       
        addObject(new LadoV(), 0, 0);
        addObject(new LadoV(), 0, 275);
        addObject(new LadoH(), 0, 0);
        addObject(new LadoH(), 275, 0);
        
        addObject(new LadoV(), 496, 0);
        addObject(new LadoV(), 496, 275);
        addObject(new LadoH(), 0, 496);
        addObject(new LadoH(), 275, 496);
        
        
        
    }
    
    /**
     * Visualiza el numero de vidas que tiene el jugador 
     *
     */
    private void visualizaVida()
    {
        Numero vida =  new Numero();
        
        vida.cambiaNumero(contV);
        addObject(vida, 523, 83);
        addObject(new Imagen(), 523, 28);

    }
    
    /**
     * Visualiza el numero del nivel en el que se encuentra el jugador 
     *
     */
    
    private void visualizaNivel()
    {
        Numero nivel =  new Numero();
        
        nivel.cambiaNumero(cont+1);
        addObject(nivel, 523, 193);
        
        Imagen n =  new Imagen();
        
        n.cambiaImagen(1);
        addObject(n, 523, 138);

    }
    
    /**
     * Crea los cubos grises que siempre aparecen, a excepcion del ultimo escenario
     * 
     */
    private void siempre(){
        
        
        int aux = 55;
        
        for(int i = 0; i < 10; i++){
            addObject(new Pared(), 28 + aux*i ,522 );
            addObject(new Pared(), 522,  28 + aux*i);
        }
        
        int aux2;
        aux = 0;
        aux2 = 0;
        
        for(int j = 0; j < 4; j++){
            
            for(int i = 0; i < 4; i++){
                addObject(new Pared(), 83 + aux * i, 83 + aux2 * j);
                aux = 110;
            }
             aux2 = 110;
        }
        
        
        
        addObject(new LadoV(), 0, 0);
        addObject(new LadoV(), 0, 275);
        addObject(new LadoH(), 0, 0);
        addObject(new LadoH(), 275, 0);
        
        addObject(new LadoV(), 496, 0);
        addObject(new LadoV(), 496, 275);
        addObject(new LadoH(), 0, 496);
        addObject(new LadoH(), 275, 496);
       
        
    }
    
    /**
     * Crea los cubos cafes aleatoriamente
     * 
     * @param recibe un entero que es el  numero de cubos cafes que creara
     */
    public void scenario(int numB){
      
        
        setBackground("fondo-2.png");
        
        int j;
        int[] arre = new int[numB];
        int rando = Greenfoot.getRandomNumber(50);;  
        for(int i = 0; i < numB; i++)
        {
            j = 0;
            while(j != i)
            {
                rando = Greenfoot.getRandomNumber(50);
                while(arre[j] != rando && j < i)
                      j++;
                
                if(j != i)
                   j = 0;                
            }
            
            arre[j] = rando;
        }

        for(int k = 0; k < numB; k++)
            creaPared2(arre[k]);   
        
    }
    
    /**
     * Crea un objeto aleatoriamente, bueno puede que no, porque es aleatorio, son las super mejoras
     * 
     * @param recibe dos enteros, que son las codenadas x y "y" en los cuales se creara el objeto 
     */
    private void agregaSuperMejora(int x, int y)
    {
        int rando= Greenfoot.getRandomNumber(8);
        
        switch(rando) 
         {
             case 0 :
                    {
                        addObject(new Bomb2(), x, y);
                    }
                break;
            case 1 :
                    {
                        addObject(new BombM(), x, y);
                    }
                break;
            case 2 :
                    {
                        addObject(new LlantaM(), x, y);
                    }
                break;
            case 3 :
                  {
                       addObject(new FlamaM(), x, y);
                  }
                break;
            case 4 :
                   {
                       addObject(new FlamaS(), x, y);
                   }
                break;
            }
    }
    
    /**
     * Crea las mejoras aleatoriamente
     * 
     * @param recibe dos enteros que son las codenadas donde seran creados
     */
    
    private void agregaMejora(int x, int y)
    {
        int rando= Greenfoot.getRandomNumber(8);
        
        switch(rando) 
         {
             case 0 :
                    {
                        
                    }
                break;
            case 1 :
                    {
                        addObject(new Bomb(), x, y);
                    }
                break;
            case 2 :
                    {
                        addObject(new Llanta(), x, y);
                    }
                break;
            case 3 :
                  {
                       addObject(new Flama(), x, y);
                  }
                break;
            case 4 :
                   {
                       agregaSuperMejora(x, y);
                   }
                break;
            case 5 :
                   {
                     
                   }
                break;
            case 6 :
                   {
                       
                   }
                break;
            case 7 :
                   {
                       
                   }
                break;
        }
        
    }
    
    
    
    /**
     * Crea enemigos, y los coloca aleatoriamente en el juego
     * 
     * @param recibe dos enteros uno es para el numero de enemigos a crear y el otro es el tipo de enemigo 
     */
    
    private void creaEnemigos(int num, int tipo)
    {
        int random= Greenfoot.getRandomNumber(11);
        
        for(int i = 0; i < num; i++)
        {
                switch(random) 
                 {
                     case 0 :
                            {
                               creaEnemigo( 358, 28, tipo);
                            }
                        break;
                    case 1 :
                            {
                                creaEnemigo( 468, 28, tipo);
                            }
                        break;
                    case 2 :
                            {
                                creaEnemigo( 248, 83, tipo);
                            }
                        break;
                    case 3 :
                          {
                               creaEnemigo( 193, 138, tipo);
                          }
                        break;
                    case 4 :
                           {
                               creaEnemigo( 358, 193, tipo);
                           }
                        break;
                    case 5 :
                            {
                                creaEnemigo( 138, 248, tipo);
                            }
                        break;
                    case 6 :
                            {
                                creaEnemigo( 248, 248, tipo);
                            }
                        break;
                    case 7 :
                          {
                               creaEnemigo( 28, 358, tipo);
                          }
                        break;
                    case 8 :
                           {
                               creaEnemigo( 248, 358, tipo);
                           }
                        break;
                    case 9 :
                          {
                               creaEnemigo( 468, 413, tipo);
                          }
                        break;
                    case 10 :
                           {
                               creaEnemigo( 138, 468, tipo);
                           }
                        break;
                    case 11 :
                           {
                               creaEnemigo( 468, 468, tipo);
                           }
                        break;
                }
                
                random= Greenfoot.getRandomNumber(11);
       }
    }
    
    /**
     * Crea un enemigo en cierta coordenada
     * 
     * @param recibe tres enteros, dos de ellos son las coordenadas y el otro es el tipo de enemigo a crear 
     */
    private void creaEnemigo(int x, int y, int tipo)
    {
        switch(tipo) 
         {
             case 0 :
                    {
                        addObject(new Bow(), x, y);
                    }
                break;
            case 1 :
                    {
                        addObject(new Wario(), x, y);
                    }
                break;
            case 2 :
                    {
                        addObject(new Bows(), x, y);
                    }
                break;
            case 3 :
                  {
                       addObject(new Bowse(), x, y);
                  }
                break;
            case 4 :
                   {
                       
                   }
                break;
        }
    }
     
    /**
     * Crea una pared y posiblemente una mejora
     * 
     * @param recibe un entero la cual es una direccion
     */
    private void creaPared2(int rando)
    {
        
        
        switch(rando) 
         {
             case 0 :
                    {
                        agregaMejora(28, 138);
                        addObject(new Pared2(), 28, 138);
                    }
                break;
            case 1 :
                    {
                        agregaMejora(28, 193);
                        addObject(new Pared2(), 28, 193);
                    }
                break;
            case 2 :
                    {
                        agregaMejora(28, 248);
                        addObject(new Pared2(), 28, 248);
                    }
                break;
            case 3 :
                  {
                       agregaMejora(28, 413);
                       addObject(new Pared2(), 28, 413);
                  }
                break;
            case 4 :
                   {
                       agregaMejora(28, 468);
                       addObject(new Pared2(), 28, 468);
                   }
                break;
            case 5 :
                   {
                       agregaMejora(83, 248);
                       addObject(new Pared2(), 83, 248);
                   }
                break;
            case 6 :
                   {
                       agregaMejora(83, 468);
                       addObject(new Pared2(), 83, 468);
                   }
                break;
            case 7 :
                   {
                       agregaMejora(83, 138);
                       addObject(new Pared2(), 83, 138);
                   }
                break;
            case 8 :
                   {
                       agregaMejora(138, 28);
                       addObject(new Pared2(), 138, 28);
                   }
                break;
            case 9 :
                   {
                       agregaMejora(138, 83);
                       addObject(new Pared2(), 138, 83);
                   }
                break;
            case 10 :
                   {
                       agregaMejora(138, 138);
                       addObject(new Pared2(), 138, 138);
                   }
                break;
            case 11 :
                   {
                       agregaMejora(138, 193);
                       addObject(new Pared2(), 138, 193);
                   }
                break;
            case 12 :
                   {
                       agregaMejora(138, 303);
                       addObject(new Pared2(), 138, 303);
                   }
                break;
            case 13 :
                   {
                       agregaMejora(138, 358);
                       addObject(new Pared2(), 138, 358);
                   }
                break;
            case 14 :
                   {
                       agregaMejora(193, 28);
                       addObject(new Pared2(), 193, 28);
                   }
                break;
            case 15 :
                   {
                       agregaMejora(193, 358);
                       addObject(new Pared2(), 193, 358);
                   }
                break;
            case 16 :
                   {
                       agregaMejora(248, 28);
                       addObject(new Pared2(), 248, 28);
                   }
                break;
            case 17 :
                   {
                       agregaMejora(248, 193);
                       addObject(new Pared2(), 248, 193);
                   }
                break;
            case 18 :
                   {
                       agregaMejora(248, 303);
                       addObject(new Pared2(), 248, 303);
                   }
                break;
            case 19 :
                   {
                       agregaMejora(248, 413);
                       addObject(new Pared2(), 248, 413);
                   }
                break;
            case 20 :
                   {
                       agregaMejora(248, 468);
                       addObject(new Pared2(), 248, 468);
                   }
                break;
            case 21 :
                   {
                       agregaMejora(303, 28);
                       addObject(new Pared2(), 303, 28);
                   }
                break;
            case 22 :
                   {
                       agregaMejora(303, 138);
                       addObject(new Pared2(), 303, 138);
                   }
                break;
            case 23 :
                   {
                       agregaMejora(303, 248);
                       addObject(new Pared2(), 303, 248);
                   }
                break;
            case 24 :
                   {
                       agregaMejora(303, 468);
                       addObject(new Pared2(), 303, 468);
                   }
                break;
            case 25 :
                   {
                       agregaMejora(358, 83);
                       addObject(new Pared2(), 358, 83);
                   }
                break;
            case 26 :
                   {
                       agregaMejora(358, 248);
                       addObject(new Pared2(), 358, 248);
                   }
                break;
            case 27 :
                   {
                       agregaMejora(358, 303);
                       addObject(new Pared2(), 358, 303);
                   }
                break;
            case 28 :
                   {
                       agregaMejora(358, 358);
                       addObject(new Pared2(), 358, 358);
                   }
                break;
            case 29 :
                   {
                       agregaMejora(358, 413);
                       addObject(new Pared2(), 358, 413);
                   }
                break;
            case 30 :
                   {
                       agregaMejora(358, 468);
                       addObject(new Pared2(), 358, 468);
                   }
                break;
            case 31 :
                   {
                       agregaMejora(413, 138);
                       addObject(new Pared2(), 413, 138);
                   }
                break;
            case 32 :
                   {
                       agregaMejora(413, 248);
                       addObject(new Pared2(), 413, 248);
                   }
                break;
            case 33 :
                   {
                       agregaMejora(413,358);
                       addObject(new Pared2(), 413,358);
                   }
                break;
            case 34 :
                   {
                       agregaMejora(468, 83);
                       addObject(new Pared2(), 468, 83);
                   }
                break;
            case 35 :
                   {
                       agregaMejora(468, 138);
                       addObject(new Pared2(), 468, 138);
                   }
                break;
            case 36 :
                   {
                       agregaMejora(468, 193);
                       addObject(new Pared2(), 468, 193);
                   }
                break;
            case 37 :
                   {
                       agregaMejora(468, 248);
                       addObject(new Pared2(), 468, 248);
                   }
                break;
            case 38 :
                   {
                       agregaMejora(468, 303);
                       addObject(new Pared2(), 468, 303);
                   }
                break;
            case 39 :
                   {
                       agregaMejora(468, 358);
                       addObject(new Pared2(), 468, 358);
                   }
                break;
            case 40 :
                   {
                       agregaMejora(28, 303);
                       addObject(new Pared2(), 28, 303);
                   }
                break;
            case 41 :
                   {
                       agregaMejora(83, 358);
                       addObject(new Pared2(), 83, 358);
                   }
                break;
            case 42 :
                   {
                       agregaMejora(138, 413);
                       addObject(new Pared2(), 138, 413);
                   }
                break;
            case 43 :
                   {
                       agregaMejora(193, 468);
                       addObject(new Pared2(), 193, 468);
                   }
                break;
            case 44 :
                   {
                       agregaMejora(248, 138);
                       addObject(new Pared2(), 248, 138);
                   }
                break;
            case 45 :
                   {
                       agregaMejora(193, 248);
                       addObject(new Pared2(), 193, 248);
                   }
                break;
            case 46 :
                   {
                       agregaMejora(303, 358);
                       addObject(new Pared2(), 303, 358);
                   }
                break;
            case 47 :
                   {
                       agregaMejora(358, 138);
                       addObject(new Pared2(), 358, 138);
                   }
                break;
            case 48 :
                   {
                       agregaMejora(413, 28);
                       addObject(new Pared2(), 413, 28);
                   }
                break;
            case 49 :
                   {
                       agregaMejora(413, 468);
                       addObject(new Pared2(), 413, 468);
                   }
                break;
         }
    
    
    }
    
    
    
}
